﻿using Infragistics.Controls.Maps;
using Infragistics.Win.DataVisualization;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp1
{
    public partial class Form1 : Form
    {
       public Form1()
        {
            InitializeComponent();
         
            var geoMap = new UltraGeographicMap();

            OpenStreetMapImagery openStreet = new OpenStreetMapImagery();

            openStreet.DownloadingImage += Openstreet_DownloadingImage;
            openStreet.CancellingImage += Openstreet_CancellingImage;

            geoMap.SetImagery(openStreet);

            geoMap.Dock = DockStyle.Fill;
            geoMap.Zoomable = true;
            this.Controls.Add(geoMap);                    
        }


        Dictionary<string, WebClient> RequestedTiles = new Dictionary<string, WebClient>();
        private void Openstreet_DownloadingImage(object sender, DownloadingMultiScaleImageEventArgs args)
        {           
            
            args.AlternateDownloadHandler = (u, o, a) =>
            {
                WebClient downloadClient = new WebClient();
                downloadClient.Headers.Add(HttpRequestHeader.Referer, "https://www.mydomain.com/overview");
                downloadClient.Headers.Add(HttpRequestHeader.UserAgent, "MyApp");

                downloadClient.DownloadDataCompleted += (object s, DownloadDataCompletedEventArgs e) =>
                {
                    if (RequestedTiles.ContainsKey(u.ToString()))
                    {
                        if (e.Error == null && !e.Cancelled)
                        {
                            a.Invoke(u, o, e.Result);
                        } 
                        RequestedTiles.Remove(u.ToString());
                    }

                };
                 RequestedTiles.Add(args.Uri, downloadClient);
                downloadClient.DownloadDataAsync(u, o);

            };
        }

        private void Openstreet_CancellingImage(object sender, CancellingMultiScaleImageEventArgs args)
        {
          if (RequestedTiles.ContainsKey(args.Uri))
            {
                WebClient request = RequestedTiles[args.Uri];
                request.CancelAsync();
                RequestedTiles.Remove(args.Uri);
            }
        }
    }
}
